#!/bin/bash

# @author      xqyjlj
# @file        run.sh
#
# Change Logs:
# Date           Author       Notes
# ------------   ----------   -----------------------------------------------
# 2023-01-12     xqyjlj       initial version
#

type=${1}

if [ ! -n "${type}" ]; then
    type="fat"
fi

qemu-system-riscv64 \
    -machine virt \
    -m 256M \
    -kernel rtthread.bin \
    -nographic \
    -drive if=none,file=ext4.img,format=raw,id=blk0 \
    -device virtio-blk-device,drive=blk0,bus=virtio-mmio-bus.0 \
    -drive if=none,file=${type}.img,format=raw,id=blk1 \
    -device virtio-blk-device,drive=blk1,bus=virtio-mmio-bus.1 \
    -netdev user,id=tap0,hostfwd=tcp::58080-:80 \
    -device virtio-net-device,netdev=tap0,bus=virtio-mmio-bus.2 \
    -device virtio-serial-device \
    -chardev socket,host=127.0.0.1,port=43211,server=on,wait=off,telnet=on,id=console0 \
    -device virtserialport,chardev=console0
